package animation;

import graph.LayeredGraphNode;
import view.MainView;

public abstract class AnimatedAlgorithm extends Thread implements AlgorithmStage {

	protected AnimationController ac;
	protected LayeredGraphNode graph;
	
	public AnimatedAlgorithm( AnimationController controller, LayeredGraphNode graph )
	{
		this.ac = controller;
		this.graph = graph;
	}
	
	@Override
	public void run()
	{
		while( true ) // if this loop would end we could not undo steps any more
		{
			try {
				switch( ac.getNextAction() )
				{
				case FORWARD:
					forwardStep();
                    MainView.frame.repaint();
					break;
                case FORWARD_OUT:
                    forwardStepOut();
                    MainView.frame.repaint();
                    break;
                case FORWARD_OVER:
                    forwardStepOver();
                    MainView.frame.repaint();
                    break;
				case BACKWARD:
					backwardStep();
                    MainView.frame.repaint();
					break;
                case BACKWARD_OUT:
                    backwardStepOut();
                    MainView.frame.repaint();
                    break;
                case BACKWARD_OVER:
                    backwardStepOver();
                    MainView.frame.repaint();
                    break;
                default:
                    break;
				}
			} catch (InterruptedException e) {
				e.printStackTrace();
				return;
			}
			
		}
	}
	
    public abstract PseudoCodeNode createPseudocodeTree();
}
